=== debian/changelog ===
xsimd (7.6.0-2) unstable; urgency=medium

  * Fix failing autopkgtest on i386 (Closes: #994169)

 -- Julien Lamy <lamy@unistra.fr>  Thu, 28 Oct 2021 07:54:28 +0200

xsimd (7.6.0-1) unstable; urgency=medium

  * New upstream version 7.6.0

 -- Julien Lamy <lamy@unistra.fr>  Thu, 14 Oct 2021 01:00:57 +0530

xsimd (7.5.0-1) unstable; urgency=medium

  * Initial release (Closes: #867915)

 -- Julien Lamy <lamy@unistra.fr>  Wed, 21 Apr 2021 11:56:53 +0200
