=== debian/tests/control ===
Test-Command: set -e
 ; cp -r ./benchmark/* "$AUTOPKGTEST_TMP"
 ; cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with gcc:"
 ; g++ -DXSIMD_ENABLE_FALLBACK -Ofast main.cpp -o benchmark
 ; ./benchmark op
Depends: g++,
         libxsimd-dev
Restrictions: allow-stderr

Test-Command: set -e
 ; cp -r ./benchmark/* "$AUTOPKGTEST_TMP"
 ; cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with clang:"
 ; clang++ -DXSIMD_ENABLE_FALLBACK -Ofast main.cpp -o benchmark
 ; ./benchmark op
Depends: clang,
         libxsimd-dev
Restrictions: allow-stderr
