=== debian/changelog ===
xsimd (8.1.0-7~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Bump minver of BD xtl-dev to 0.7.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 13 Sep 2022 16:46:30 -0700

xsimd (8.1.0-7) unstable; urgency=medium

  * Mark as incompatible with pythran < 0.11

 -- Julien Lamy <lamy@unistra.fr>  Mon, 11 Jul 2022 09:26:15 +0200

xsimd (8.1.0-6) unstable; urgency=medium

  * Mark as incompatible with xtensor < 0.24

 -- Julien Lamy <lamy@unistra.fr>  Sat, 09 Jul 2022 08:33:17 +0200

xsimd (8.1.0-5) unstable; urgency=medium

  * Run autopkgtest on all architectures

 -- Julien Lamy <lamy@unistra.fr>  Thu, 30 Jun 2022 09:01:13 +0200

xsimd (8.1.0-4) unstable; urgency=medium

  * Reintroduce build on all arches (Closes: #1010595)
  * Run autopkgtests on supported architectures only

 -- Julien Lamy <lamy@unistra.fr>  Mon, 27 Jun 2022 06:58:27 +0200

xsimd (8.1.0-3) unstable; urgency=medium

  * Fix compilation on arm64 and armhf

 -- Julien Lamy <lamy@unistra.fr>  Fri, 24 Jun 2022 11:27:00 +0200

xsimd (8.1.0-2) unstable; urgency=medium

  * Depend on xtl
  * Fix compatibility with xtl::xcomplex

 -- Julien Lamy <lamy@unistra.fr>  Wed, 21 Jun 2022 11:09:47 +0200

xsimd (8.1.0-1) unstable; urgency=medium

  [ Ileana Dumitrescu ]
  * New upstream version 8.0.5
  * updated changelog

  [ Julien Lamy ]
  * New upstream version 8.1.0
  * Restrict to officially supported architectures (Closes: #1010595)

 -- Julien Lamy <lamy@unistra.fr>  Fri, 03 Jun 2022 16:37:16 +0200

xsimd (8.0.3-1) experimental; urgency=medium

  * New upstream version 8.0.3

 -- Julien Lamy <lamy@unistra.fr>  Tue, 16 Nov 2021 07:22:08 +0100
