=== benchmark/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,7 @@
 # Copyright (c) Johan Mabille, Sylvain Corlay, Wolf Vollprecht and         #
 # Martin Renou                                                             #
 # Copyright (c) QuantStack                                                 #
+# Copyright (c) Serge Guelton                                              #
 #                                                                          #
 # Distributed under the terms of the BSD 3-Clause License.                 #
 #                                                                          #
@@ -14,7 +15,7 @@
     project(xsimd-benchmark)
 
     find_package(xsimd REQUIRED CONFIG)
-    set(XSIMD_INCLUDE_DIR ${xsimd_INCLUDE_DIR})
+    set(XSIMD_INCLUDE_DIR ${xsimd_INCLUDE_DIRS})
 endif ()
 
 if(NOT CMAKE_BUILD_TYPE)
@@ -29,17 +30,26 @@
 string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)
 
 if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Intel")
-    if(NOT CMAKE_CXX_FLAGS MATCHES "-march")
+    if(NOT CMAKE_CXX_FLAGS MATCHES "-march" AND NOT CMAKE_CXX_FLAGS MATCHES "-arch" AND NOT CMAKE_OSX_ARCHITECTURES)
         set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
     endif()
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wunused-parameter -Wextra -Wreorder -Wconversion")
 
     if(NOT MSVC)
         CHECK_CXX_COMPILER_FLAG("-std=c++11" HAS_CPP11_FLAG)
-        if (HAS_CPP11_FLAG)
-            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+        if (ENABLE_XTL_COMPLEX)
+            CHECK_CXX_COMPILER_FLAG("-std=c++14" HAS_CPP14_FLAG)
+            if (NOT HAS_CPP14_FLAG)
+                message(FATAL_ERROR "Unsupported compiler -- xsimd requires C++14 support when xtl complex support is enabled")
+            endif()
+            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
         else()
-            message(FATAL_ERROR "Unsupported compiler -- xsimd requires C++11 support!")
+            CHECK_CXX_COMPILER_FLAG("-std=c++11" HAS_CPP11_FLAG)
+            if (NOT HAS_CPP11_FLAG)
+                message(FATAL_ERROR "Unsupported compiler -- xsimd requires C++11 support!")
+            else()
+                set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+            endif()
         endif()
     endif()
 endif()
@@ -65,4 +75,8 @@
 set(XSIMD_BENCHMARK_TARGET benchmark_xsimd)
 add_executable(${XSIMD_BENCHMARK_TARGET} ${XSIMD_BENCHMARK} ${XSIMD_HEADERS})
 
+if(ENABLE_XTL_COMPLEX)
+    target_link_libraries(benchmark_xsimd PRIVATE xtl)
+endif()
+
 add_custom_target(xbenchmark COMMAND benchmark_xsimd DEPENDS ${XSIMD_BENCHMARK_TARGET})
