=== debian/changelog ===
xsimd (10.0.0-3) unstable; urgency=medium

  * Team upload.
  * upload xsimd 10 to unstable (xtl 0.7.5 now available)

 -- Drew Parsons <dparsons@debian.org>  Mon, 25 Sep 2023 10:40:07 +0200

xsimd (10.0.0-2) experimental; urgency=medium

  * Team upload.
  * drop -mfpu=neon buildflag for armhf. Closes: #1029568.

 -- Drew Parsons <dparsons@debian.org>  Fri, 05 May 2023 18:46:50 +0200

xsimd (10.0.0-1) experimental; urgency=medium

  * New upstream release (Closes: 1027757)

 -- Julien Lamy <lamy@unistra.fr>  Tue, 03 Jan 2023 08:42:02 +0100
