=== debian/changelog ===
xsimd (12.1.1-3build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:51:54 +1100

xsimd (12.1.1-3) unstable; urgency=medium

  * Team upload.
  * debian patch check_arch_flags_PR1010.patch applies upstream PR1010
    to check arch flag support. Enables clang tests on ppc64el.

 -- Drew Parsons <dparsons@debian.org>  Tue, 19 Mar 2024 21:20:10 +0100

xsimd (12.1.1-2) unstable; urgency=medium

  * Team upload.
  * debian/tests: disable clang tests on ppc64el
    (upstream issue #999)

 -- Drew Parsons <dparsons@debian.org>  Sat, 27 Jan 2024 19:52:14 +0100

xsimd (12.1.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - armhf was giving neon trouble with v11, so try again with v12
    - applies debian patch batch_bool_PR973.patch
  * build armhf tests with -mfpu=vfpv3 to ensure neon is not invoked.
    See https://github.com/llvm/llvm-project/issues/30190
    cf. upstream issue #889. (note, this fails with v11)

 -- Drew Parsons <dparsons@debian.org>  Sat, 20 Jan 2024 19:57:11 +0100

xsimd (11.2.0-2) unstable; urgency=medium

  * Team upload.
  * debian patch batch_bool_PR973.patch applies upstream PR#973 to
    remove batch of bools. May fix armhf builds, see upstream #945.
  * libxsimd-dev Depends: xtl-dev (>= 0.7.0~). Only needed when
    ENABLE_XTL_COMPLEX is set, but it is configured ON.
    Thanks Kentaro HAYASHI. Closes: #1061104.

 -- Drew Parsons <dparsons@debian.org>  Sat, 20 Jan 2024 12:57:28 +0100

xsimd (11.2.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - applies debian patch xtl_complex_PR950.patch

 -- Drew Parsons <dparsons@debian.org>  Sat, 20 Jan 2024 10:43:00 +0100

xsimd (11.1.0-1exp5) experimental; urgency=medium

  * Team upload.
  * debian patch xtl_complex_PR950.patch applies upstream PR#950 to
    ensure both XSIMD_ENABLE_XTL_COMPLEX and cxx_std_14 support is
    activated when ENABLE_XTL_COMPLEX is set
    - debian/tests: drop redundant *complex-complex tests

 -- Drew Parsons <dparsons@debian.org>  Mon, 09 Oct 2023 13:02:03 +0200

xsimd (11.1.0-1exp4) experimental; urgency=medium

  * Team upload.
  * debian/tests Depends: g++

 -- Drew Parsons <dparsons@debian.org>  Wed, 27 Sep 2023 14:05:09 +0200

xsimd (11.1.0-1exp3) experimental; urgency=medium

  * Team upload.
  * debian/tests Depends: doctest-dev

 -- Drew Parsons <dparsons@debian.org>  Wed, 27 Sep 2023 03:32:24 +0200

xsimd (11.1.0-1exp2) experimental; urgency=medium

  * Team upload.
  * debian/tests add Depends: xtl-dev, cmake

 -- Drew Parsons <dparsons@debian.org>  Tue, 26 Sep 2023 17:31:15 +0200

xsimd (11.1.0-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Standards-Version: 4.6.2
  * debian/tests: run upstream tests, including tests with complex
    number support (ENABLE_XTL_COMPLEX)
  * also add complex-complex tests activating XSIMD_ENABLE_XTL_COMPLEX
    alongside ENABLE_XTL_COMPLEX (see upstream Issue #942)

 -- Drew Parsons <dparsons@debian.org>  Sun, 24 Sep 2023 14:15:42 +0200
