=== debian/control ===
--- 
+++ 
@@ -1,15 +1,17 @@
 Source: xsimd
 Section: science
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Julien Lamy <lamy@unistra.fr>
 Build-Depends: debhelper-compat (= 13),
                cmake,
+               xtl-dev (>= 0.7.0~),
                python3-breathe <!nodoc>,
                python3-sphinx <!nodoc>,
                python3-sphinx-rtd-theme <!nodoc>,
-               libgtest-dev <!nocheck>
-Standards-Version: 4.6.0
+               doctest-dev <!nocheck>
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/science-team/xsimd
 Vcs-Git: https://salsa.debian.org/science-team/xsimd.git
 Homepage: https://github.com/xtensor-stack/xsimd
@@ -19,8 +21,11 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: ${misc:Depends}
+Depends: xtl-dev (>= 0.7.0~),
+ ${misc:Depends}
 Suggests: libxsimd-doc <!nodoc>
+Breaks: libxtensor-dev (<< 0.24~),
+        python3-pythran (<< 0.11~)
 Description: C++ wrappers for SIMD intrinsics
  SIMD (Single Instruction, Multiple Data) is a feature of microprocessors
  that has been available for many years. SIMD instructions perform a
@@ -38,10 +43,11 @@
 
 Package: libxsimd-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends},
          ${sphinxdoc:Depends}
-Built-Using: ${sphinxdoc:Built-Using}
+Build-Profiles: <!nodoc>
 Description: Documentation for xsimd
  SIMD (Single Instruction, Multiple Data) is a feature of microprocessors
  that has been available for many years. SIMD instructions perform a
@@ -56,4 +62,3 @@
  on batches.
  .
  This package provides the documentation.
-Build-Profiles: <!nodoc>
